summaryrefslogtreecommitdiffstats
path: root/development/fpc/fpc.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'development/fpc/fpc.SlackBuild')
-rw-r--r--development/fpc/fpc.SlackBuild178
1 files changed, 127 insertions, 51 deletions
diff --git a/development/fpc/fpc.SlackBuild b/development/fpc/fpc.SlackBuild
index e893499c9b..a7399aec49 100644
--- a/development/fpc/fpc.SlackBuild
+++ b/development/fpc/fpc.SlackBuild
@@ -2,7 +2,10 @@
# Slackware build script for Free Pascal
-# Written by Andre Barboza <bmg.andre@gmail.com>
+# Maintained by Antonio Leal <antonioleal@yahoo.com>.
+# Previously maintained by B. Watson <urchlay@slackware.uk>.
+# Modified by the SlackBuilds.org project.
+# Written by Andre Barboza <email removed>.
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
@@ -20,15 +23,37 @@
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-#
-# Modified by the SlackBuilds.org project.
+
+# 20231229 ALe: BUILD=3
+# Imported Debian patches to support -fPIC option, improved timestamps.
+# Added fpc source code with option to exclude it.
+
+# 20230814 ALe: BUILD=2
+# - tested conflict with ptop: it no longer exists because in ptop SlackBuild
+# the name /usr/bin/ptop.py is now being used.
+
+# 20230520 bkw: ARCH is now i586, use separate SRCARCH for the i386
+# in the source filenames. I severely doubt this would run on a 386
+# anyway. i586 is the minimum *Slackware supported* ARCH this will run
+# on. Not bumping BUILD because the package contents don't change.
+
+# 20220415 bkw: BUILD=2
+# - remove *.rsj files from /usr/bin.
+
+# 20210904 bkw:
+# - take over maintenance.
+# - update for v3.2.2.
+# - install the IDE's data files to fpc base dir, not /usr/bin (ugh).
+# - include man page for instantfpc/ifpc.
+# - TODO: find out why exiting fp (the IDE) leaves the cursor blinking.
+# It's *very* annoying but not a showstopper.
cd $(dirname $0) ; CWD=$(pwd)
PRGNAM=fpc
-VERSION=${VERSION:-3.0.4}
-BINVERSION=${BINVERSION:-3.0.4}
-BUILD=${BUILD:-1}
+VERSION=${VERSION:-3.2.2}
+BINVER=${BINVER:-3.2.2}
+BUILD=${BUILD:-3}
TAG=${TAG:-_SBo}
PKGTYPE=${PKGTYPE:-tgz}
@@ -40,23 +65,12 @@ if [ -z "$ARCH" ]; then
esac
fi
-# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
-# the name of the created package would be, and then exit. This information
-# could be useful to other scripts.
-if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
- echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
- exit 0
-fi
-
-TMP=${TMP:-/tmp/SBo}
-PKG=$TMP/package-$PRGNAM
-OUTPUT=${OUTPUT:-/tmp}
-
case "$ARCH" in
- i?86) ARCH="i386"
+ i?86) ARCH="i586"
+ SRCARCH="i386"
LIBDIRSUFFIX=""
;;
- x86_64) ARCH="x86_64"
+ x86_64) SRCARCH="x86_64"
LIBDIRSUFFIX="64"
;;
*) printf "$ARCH is not supported...\n"
@@ -64,40 +78,77 @@ case "$ARCH" in
;;
esac
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
set -e
+fixperms() {
+ chown -R root:root .
+ find -L . -type l -o \
+ -perm /111 -a \! -perm 755 -a -exec chmod 755 {} \+ -o \
+ \! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} \+
+}
+
rm -rf $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
-rm -rf $PRGNAM-$BINVERSION ${PRGNAM}build-$VERSION
-mkdir $PRGNAM-$BINVERSION ${PRGNAM}build-$VERSION
-cd $TMP/$PRGNAM-$BINVERSION
-tar xvf $CWD/$PRGNAM-$BINVERSION.$ARCH-linux.tar --strip-components=1
+rm -rf $PRGNAM-$BINVER ${PRGNAM}build-$VERSION
+mkdir $PRGNAM-$BINVER ${PRGNAM}build-$VERSION
+cd $TMP/$PRGNAM-$BINVER
+tar xvf $CWD/$PRGNAM-$BINVER.$SRCARCH-linux.tar --strip-components=1
cd $TMP/${PRGNAM}build-$VERSION
tar xvf $CWD/${PRGNAM}build-$VERSION.tar.gz
-# Unpack binary files.
+# Unpack binary files. This is the bootstrap compiler; these binaries
+# don't get installed as part of the package.
(
- mkdir -p $TMP/$PRGNAM-$BINVERSION/binary
- cd $TMP/$PRGNAM-$BINVERSION/binary
- tar xvf $TMP/$PRGNAM-$BINVERSION/binary.$ARCH-linux.tar
+ mkdir -p $TMP/$PRGNAM-$BINVER/binary
+ cd $TMP/$PRGNAM-$BINVER/binary
+ tar xvf $TMP/$PRGNAM-$BINVER/binary.$SRCARCH-linux.tar
- cd $TMP/$PRGNAM-$BINVERSION
- tar xvf $TMP/$PRGNAM-$BINVERSION/binary/base.$ARCH-linux.tar.gz
- tar xvf $TMP/$PRGNAM-$BINVERSION/binary/utils.$ARCH-linux.tar.gz
+ cd $TMP/$PRGNAM-$BINVER
+ tar xvf $TMP/$PRGNAM-$BINVER/binary/base.$SRCARCH-linux.tar.gz
+ tar xvf $TMP/$PRGNAM-$BINVER/binary/utils.$SRCARCH-linux.tar.gz
- cd $TMP/$PRGNAM-$BINVERSION/bin
- if [ "$ARCH" = "x86_64" ]; then
- ln -s ../lib/fpc/$BINVERSION/ppcx64
+ cd $TMP/$PRGNAM-$BINVER/bin
+ if [ "$SRCARCH" = "x86_64" ]; then
+ ln -s ../lib/fpc/$BINVER/ppcx64
else
- ln -s ../lib/fpc/$BINVERSION/ppc386
+ ln -s ../lib/fpc/$BINVER/ppc386
fi
)
-export PATH="$TMP/$PRGNAM-$BINVERSION/bin":$PATH
-echo $PATH
+export PATH="$TMP/$PRGNAM-$BINVER/bin":$PATH
+echo "=== PATH is $PATH"
cd $TMP/${PRGNAM}build-$VERSION/${PRGNAM}build-$VERSION
+
+# it's => its. It's one of my pet peeves; its occurrence annoys me.
+sed -i "s,\\(as\\|control\\) it's,\\1 its," install/man/man?/*.?
+
+# 20210905 bkw: patch taken from Debian with many thanks. Installs the
+# - IDE's data files somewhere besides /usr/bin, and patches the IDE to look for them there.
+patch -p1 < $CWD/patches/fix-IDE-data-file-location.patch
+# 20240113 ALe: Patches imported from Debian fpc_3.2.2+dfsg-20.debian.tar.xz :
+# - Fixed liking with libc when PIC is enabled (x86_64 specific)
+patch -p1 < $CWD/patches/Fix-liking-with-libc-when-PIC-is-enabled.patch
+# - Add glibc2.34.patch to adjust startup code for glibc2.34 (Closes: #1016556)
+patch -p1 < $CWD/patches/glibc2.34.patch
+# - Reproducibility never ends: add honor_SOURCE_DATE_EPOCH_in_date.patch to improve some timestamps in binaries
+patch -p1 < $CWD/patches/honor_SOURCE_DATE_EPOCH_in_date.patch
+
+# 20210905 bkw: don't let the NOGDB=1 scare you. During the compile
+# we get this message:
+# Compiling IDE with GDB/MI debugger support, LibGDB is not needed
+# ...and it appears that the IDE does indeed have its debugging
+# support enabled.
make build NOGDB=1
make -j1 NOGDB=1 PREFIX=$PKG/usr install
@@ -105,21 +156,50 @@ make -j1 NOGDB=1 PREFIX=$PKG/usr install
[ "$LIBDIRSUFFIX" = "64" ] && mv $PKG/usr/lib $PKG/usr/lib${LIBDIRSUFFIX}
cd $PKG/usr/bin
-if [ "$ARCH" = "x86_64" ]; then
+if [ "$SRCARCH" = "x86_64" ]; then
ln -s ../lib$LIBDIRSUFFIX/fpc/$VERSION/ppcx64
else
ln -s ../lib$LIBDIRSUFFIX/fpc/$VERSION/ppc386
fi
+# 20231229 ALe: Optionally exclude the source from the package.
+# Source is required by some apps (e.g lazarus IDE).
+if [ "${SRC:-yes}" = "yes" ]; then
+ mkdir -p $PKG/usr/src
+ ( cd $PKG/usr/src
+ tar xvf $CWD/fpc-$VERSION.source.tar.gz
+ fixperms
+ ln -s fpc-$VERSION fpc
+ )
+fi
+
# copy docs
mv $PKG/usr/share/doc $PKG/usr/doc
rmdir $PKG/usr/share
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
-find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
- | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+# 20220415 bkw: compiled pascal programs don't use .rsj files at
+# runtime. see https://wiki.lazarus.freepascal.org/Using_resourcestrings
+# and note that there are no *.mo files in this package.
+rm -f $PKG/usr/bin/*.rsj
+
+# 20210905 bkw: fancier than the template, but quite a bit faster and less
+# resource-intensive.
+find $PKG -type f -a -perm /111 | \
+ xargs file -m /etc/file/magic/elf | \
+ grep -e "executable" -e "shared object" | grep ELF | \
+ cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null || true
+
+# we include one man page borrowed from Debian and edited for
+# grammar and accuracy.
+cat $CWD/instantfpc.1 > $PKG/usr/man/man1/instantfpc.1
+
+gzip $PKG/usr/man/man?/*.*
-find $PKG/usr/man -type f -exec gzip -9 {} \;
+# no idea why Debian renames instantfpc => ifpc, so support both names.
+ln -s instantfpc.1.gz $PKG/usr/man/man1/ifpc.1.gz
+ln -s instantfpc $PKG/usr/bin/ifpc
# Create compiler config file.
mkdir -p $PKG/etc $PKG/usr/lib$LIBDIRSUFFIX/fpc/$VERSION/ide/text
@@ -128,10 +208,11 @@ $PKG/usr/lib$LIBDIRSUFFIX/fpc/$VERSION/samplecfg \
$PKG/etc
# Clean up the configs by removing our package directory.
-sed -i -e "s:$PKG::g" $PKG/etc/fpc.cfg
-sed -i -e "s:$PKG::g" $PKG/etc/fppkg.cfg
-sed -i -e "s:$PKG::g" $PKG/etc/fppkg/default
-sed -i -e "s:$PKG::g" $PKG/usr/lib$LIBDIRSUFFIX/fpc/$VERSION/ide/text/fp.cfg
+sed -i -e "s:$PKG::g" \
+ $PKG/etc/fpc.cfg \
+ $PKG/etc/fppkg.cfg \
+ $PKG/etc/fppkg/default \
+ $PKG/usr/lib$LIBDIRSUFFIX/fpc/$VERSION/ide/text/fp.cfg
mv $PKG/etc/fpc.cfg $PKG/etc/fpc.cfg.new
mkdir -p $PKG/install
@@ -140,11 +221,6 @@ cat $CWD/doinst.sh > $PKG/install/doinst.sh
cd $PKG
# fix permissions for program docs and demos.
-chown -R root:root .
-find -L . \
- \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
- -o -perm 511 \) -exec chmod 755 {} \; -o \
- \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
- -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+fixperms
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE